<script setup lang="ts">
import { ref, watch } from "vue";
import searchConfig from "./config/search.config";
import contentConfig from "./config/content.config";

import { PageContentInstance } from "/@/components/PageContent";
import { useRenderIcon } from "/@/components/ReIcon/src/hooks";
import { usePageSearch, type PageHooks } from "/@/hooks/page";
import { isBeyondTime } from "/@/views/time/_utils";
import { frontEndExport } from "/@/utils/export";
import { usePermission } from "/@/hooks/core";
import { useUserStore } from "/@/store/modules/user";


const pageName = "reportDaily";
const { hasPermissionWithCode } = usePermission(pageName);
const pageContentRef = ref<PageContentInstance | null>(null);

const userStore = useUserStore();

const hooks: PageHooks = {
  pageSearchHook: () => {
    return usePageSearch(undefined, undefined, searchConfig);
  }
};

const searchConfigRef = ref(searchConfig)
watch(
  () => userStore.level,
  level => {
    const { formItems } = searchConfigRef.value;
    const index = formItems.findIndex(({ field }) => field === "depart_id");
    const { itemid = "" } = userStore.info || {};

    if (Number(level) === 2) {
      searchConfigRef.value.formItems[index].disabled = Number(level) === 2;
      searchConfigRef.value.formItems[index].defaultValue = itemid;
    }
  },
  { immediate: true }
);

async function handleExportAllReport() {
  const params = pageContentRef.value.getBasicParams() || {};
  const { start, end } = params;
  const beyondTime = isBeyondTime({ start, end, len: 30 });
  if (beyondTime) return;
  const data = pageContentRef.value.getData();
  frontEndExport({ columns: contentConfig.columns, name: "日报.xlsx", data });
}
</script>

<template>
  <page-auth :page-name="pageName">
    <page-container
      :hooks="hooks"
      :page-name="pageName"
      :get-content-ref="ref => (pageContentRef = ref)"
      :content-config="contentConfig"
      :search-config="searchConfigRef"
    >
      <template #content_header>
        <el-button
          v-if="hasPermissionWithCode('9')"
          @click="handleExportAllReport"
          size="small"
          :icon="useRenderIcon('arrow-up-line')"
          type="primary"
          >导出</el-button
        >
      </template>
    </page-container>
  </page-auth>
</template>
